; send string to lcd
; HL - string
lcd_puts:
	mov a,m                     ; retrieve the character
        ora a
        rz                          ; return if end of string
	mov b,a
        call lcd_send_data          ; send the character out to the console
        inx h                       ; next address
        jmp lcd_puts

; ------------------------------------------------------------------------------------
; type the word in HL as four hex digits
; ------------------------------------------------------------------------------------
outhexword:     push    psw                 ; save psw
                mov     a,h                 ; get high byte
                call    outhexbyte          ; and type it
                mov     a,l                 ; get low byte
                call    outhexbyte          ; and type it
                pop     psw                 ; restore psw
                ret                         ; and return

; ------------------------------------------------------------------------------------
; type the byte in A as two hex digits
; ------------------------------------------------------------------------------------
outhexbyte:     push psw                    ;save PSW
                rrc                         ; shift
                rrc                         ; to
                rrc                         ;  left
                rrc                         ;   nibble
                call outhexnibble           ; type hex nibble
                pop psw                     ; restore data
                call outhexnibble           ; type right nibble
                ret                         ; and exit

; ------------------------------------------------------------------------------------
; type the 4 bit nibble in A as a hex digit
; ------------------------------------------------------------------------------------
outhexnibble:   push psw                    ; save PSW
                ani 0FH                     ; isolate nibble b3>b0
                cpi 10                      ; see if >9
                jc  $+5                     ; nibble <=9
                adi 7                       ; adjust alpha char
                adi '0'                     ; add in ascii 0
		mov b,a
                call lcd_send_data          ; type nibble
                pop psw
                ret

custchar:
	db   00000b
	db   00000b
	db   00000b
	db   00000b
	db   00011b
	db   01111b
	db   01111b
	db   11111b

	db   00000b
	db   00000b
	db   00000b
	db   00000b
	db   11000b
	db   11110b
	db   11110b
	db   11111b

	db   00000b
	db   00000b
	db   00000b
	db   00000b
	db   11111b
	db   11111b
	db   11111b
	db   11111b
           
	db   11111b
	db   01111b
	db   01111b
	db   00011b
	db   00000b
	db   00000b
	db   00000b
	db   00000b

	db   11111b
	db   11110b
	db   11110b
	db   11000b
	db   00000b
	db   00000b
	db   00000b
	db   00000b
           
	db   11111b
	db   11111b
	db   11111b
	db   11111b
	db   00000b
	db   00000b
	db   00000b
	db   00000b

	db   11111b
	db   11111b
	db   11111b
	db   11111b
	db   11100b
	db   11000b
	db   10000b
	db   00000b
           
	db   00000b
	db   00000b
	db   00000b
	db   00000b
	db   00000b
	db   00000b
	db   00000b
	db   00000b
