 cpu 8080

ram_start: equ 08000h
ram_end:   equ 0FFFFh
stack_top: equ ram_end-32

tmp_u16:   equ ram_start


PIO_A		equ	00h		; 8255 base address 	  (port A)
PIO_B		equ	01h		; 8255 base address + 1 (port B)
PIO_C		equ	02h		; 8255 base address + 2 (fport C)
PIO_M		equ	03h		; 8255 control register

PIO_C_OUT       equ	80h
PIO_C_IN	equ	81h

SCL_bit	equ	4h		; SCL port PC.4
SDA_bit	equ	0h		; SDA port PC.0

lcd_slave equ 04Eh		; LCD i2c address


 org 0

 jmp start
 org 038h
start:
	lxi sp,stack_top            ; set Stack Pointer to top of ram

	mvi a,092h
	out PIO_M
;	mvi a,055h
;	out 0
;	mvi a,0AAh
;	out 1
;	mvi a,055h
;	out 2
;	sta ram_start
;	mvi a,0AAh
;	xra a
;	lda ram_start

	xra a
	sta tmp_u16
	sta tmp_u16+1

	call lcd_init

 if 1
	lxi h,copyr_txt
	call lcd_puts

	mvi b,0c0h
	call lcd_send_cmd

	lxi h,copyr_txt2
	call lcd_puts

	mvi b,094h
	call lcd_send_cmd

	lxi h,copyr_txt3
	call lcd_puts
 endif
	mvi b,0d4h
	call lcd_send_cmd

	lxi h,mem_msg
	call lcd_puts
 

	call beep
	;call outhexbyte
forever:
;	call i2c_start
;	mvi a,021h
;	call i2c_write
;	call i2c_stop

	lhld tmp_u16
	inx h
	shld tmp_u16

	mvi b,0e0h
	call lcd_send_cmd

	call outhexword
	jmp forever

beep:
	mvi d,0ffh
lp_beep:
	EI
	lxi b,1
	call delay
	DI
	lxi b,1
	call delay
	dcr d
	jnz lp_beep
	ret

;*********************************************************
;*               compare HL to DE                       *
;*                                                       *
;* if HL<=DE then carry=0                                *
;* if HL>DE  then carry=1                                *
;* the routine also increments hl.                       *
;*********************************************************
hilow:  push    b               ;save bc
        mov     b,a             ;save a
        inx     h               ;increment hl
        mov     a,h             ;test for hl=0
        ora     l               ;if yes, set zero flag
        stc                     ; and carry
        jz      hilo1           ;  and go exit
        mov     a,e             ;else
        sub     l               ; compare
        mov     a,d             ;  hl with
        sbb     h               ;    de
hilo1:  mov     a,b             ;restore a
        pop     b               ;  and bc
        ret

;*********************************************************
; delay 1 millisecond times the value in BC.
; "delay_value" has been set previously depending on the CPU type.
; (117 for 8080, 199 for 8085)
;*********************************************************
delay:          push psw
                push d
                push b
                ;lda delay_value
		mvi a,199
                mov e,a
d1:             mov d,e
d2:             dcr d
                jnz d2
                dcx b
                mov a,b
                ora c
                jnz d1
                pop b
                pop d
                pop psw
                ret


 include i2c.inc
 include lcd.inc

copyr_txt:    db "Ver 1.0 (c) Tronix",0
copyr_txt2:   db "assembled ",DATE,0
copyr_txt3:   db "at ",TIME,0
mem_msg:      db "init RAM",0
